# MetaDataApp

## Introduction
The MetaDataApp is an application for creating meta.json files for the SFB1280 Fileshare. You can create new or change existing Metafiles with it.

## Structure of the project

The structure of the project is sadly a bit messy. Due to the fact, that the gitignore file was not working, a few unnessary folders and files are also on the gitlab.

#### Important Files and Folders
- **Source code**: The code of the actual project. Found in src/AppJ_V03.java
- **Libaries**: The crucial libaries are
    - gson.2.6.2.jar
    - jcalendar-1.4.jar
    - jgoodies-forms-1.8.0.jar
    - jgoodies-forms-1.8.0-source.jar
    - json-simple-1.1.jar
    - miglayout15-swing.jar
- **.classpath**: Might be importatant to setup the libs, but this can be done manual aswell.
- **Folders which can be ignored**:
    - .metadata
    - .settings
    - bin
    - libary source folders
    - .project
    


## Structure of the code

#### Line 0 to 71:
Imports.
External Libaries:
- JSON-Simpel
- GSON

Both for JSON handling

#### Line 92 to 266
Functions for inputfield formatting.
Those functions get a input component as a parameter and add certain listener to it. For example: This could be a listener, which colors the field red, whenever the input format is not correct.

#### Line 271 to 357
Utilily functions

#### Line 358 to 370
Java main function

#### Line 371 to 470
All used variable, which can be changed and will be saved are declared and initiated here.

#### Line 476 to 584
If there is already a meta.JSON file, then this code area will read the data out of this file into the variables.

#### Line 590 to 1640
UI of the application

#### Line 1641 to 1808
Adding special features to the UI. Such as adding enforced formats to inputfields.

#### Line 1809 to 1948
Save the content to a new meta.JSON file.

#### Line 1949 - END
UI (Panels)
